#! /usr/bin/perl
#Name: rover-single-picture-client.perl
#Project: roverControl
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 28.09.2013
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Client script for rover-server.perl. Both scripts are used to operate a remote controlled rover and to do the picture upload from the webcam.

use strict;
use LWP::UserAgent;
use HTTP::Request::Common;
use Getopt::Long;
use File::Basename;
use LWP::Simple;
#use CGI; # Modul fuer CGI-Programme

$|=1 ;

my $pic_count = 0;
my $file_in = "pic01.jpg";
my $char_in = "";
my $i;
my @file_info;
my $file_size = 0;
my $char_temp = "";
my $last_pic_send = 0;
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $script_answer = "";
my $upload_command = "";
my $overlay_pic ="";
#my $random_number=0;
#my $overlay_number_name="01";
my $current_pic = 1;
my $pic_found = 0;
my $last_pic = 0;
my $cameraAngle = 11;
#my $cgi = new CGI; # neues Objekt erstellen
#my $command = $cgi->param("command");
my $command = "";


#Password must be identically in SendCurrentCommand.pl and fileupload.pl stored at the Internet server.
my $password = "YOURPASSWORD";

my $url_file_upload = "http://192.168.2.16/perl/R6/fileupload.pl";


`killall -s SIGKILL raspistill`;

`rm *.jpg`;


$upload_command = "NormalPic";

while(1==1){

    &ExecuteCommandLine("raspistill -hf -vf --width 320 --height 240 --quality 70 --timeout 500 -sh 0 --awb auto --ISO 800 -br 70 -co 70 -ss 200000 --metering average --nopreview --output $file_in", 0);

    #&ExecuteCommandLine("ffmpeg -y -i $file_in -s 320x180  -qscale 5 $file_in", 0);


    if(-e $file_in){
      #Open image file and start transfer to server
      # put timeouts, proxy etc into the useragent if needed
      print $url_file_upload . "\n";
      my $ua  = LWP::UserAgent->new();
      my $req = POST $url_file_upload, Content_Type => 'form-data', Content => [submit => 1, myfile => [ $file_in ], passwd => $password, command => $upload_command];
      my $response = $ua->request($req);

      if ($response->is_success()) {
        print "OK: ", $response->content;
      } else {
      print "ERROR: " . $response->as_string;
      &LogFile("File upload failed!");
      }

      $pic_count++;

      print "File no. " . $pic_count . " sent\n";
    }
    else{
      &LogFile("$file_in not found?!?\n");
    }

}#while(1==1){

#++++++++++++++++++++++++ LogFile ++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("R6-client.log");

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv R6-client.log R6-client01.log`
  }

  open(LOGFILE, ">> R6-client.log") || die "Can not open file 'R6-client.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

#++++++++++++++++++++++ ExecuteCommandLine ++++++++++++++++++++++++++++++++++++++++++++++++++
sub ExecuteCommandLine{
  print $_[0] . "\n";
  if($_[1] == 0){
    `$_[0]`;
  }
  else{
#    `$_[0]`;
    system $_[0];
  }
}



